#include "fx_s1516_double.h"
#include "fx_s1516_longlong.h"

int main()
{
	double sum = 0;
	int i;

#ifdef fx_mul
	fx_s1516 a = 30000;
	fx_s1516 b = 50000;

	double fa = fx_to_double(a);
	double fb = fx_to_double(b);

	printf("%lf\n", fx_s1516_double_mul(fa, fb) / P2_16);
	printf("%d\n", fx_s1516_longlong_mul0(a, b));
	printf("%d\n", fx_s1516_longlong_mul1(a, b));
	printf("%d\n", fx_s1516_longlong_mul2(a, b));
	printf("%d\n", fx_s1516_longlong_mul3(a, b));
	printf("%d\n", fx_s1516_longlong_mul4(a, b));

	for (i = 0; i < 10000000; i++)
	{
		sum += fx_s1516_double_mul(fa, fb);
	}
	for (i = 0; i < 10000000; i++)
	{
		sum += fx_s1516_longlong_mul0(a, b);
	}
	for (i = 0; i < 10000000; i++)
	{
		sum += fx_s1516_longlong_mul1(a, b);
	}
	for (i = 0; i < 10000000; i++)
	{
		sum += fx_s1516_longlong_mul2(a, b);
	}
	for (i = 0; i < 10000000; i++)
	{
		sum += fx_s1516_longlong_mul3(a, b);
	}
	for (i = 0; i < 10000000; i++)
	{
		sum += fx_s1516_longlong_mul4(a, b);
	}
#endif

#ifdef fx_div
	fx_s1516 a = 1000000;
	fx_s1516 b = 500000;

	double fa = fx_to_double(a);
	double fb = fx_to_double(b);

	printf("%lf\n", fx_s1516_double_div(fa, fb) * P2_16);
	printf("%d\n", fx_s1516_longlong_div0(a, b));
	printf("%d\n", fx_s1516_longlong_div1(a, b));
	printf("%d\n", fx_s1516_longlong_div2(a, b));

	for (i = 0; i < 10000000; i++)
	{
		sum += fx_s1516_double_div(fa, fb);
	}
	for (i = 0; i < 10000000; i++)
	{
		sum += fx_s1516_longlong_div0(a, b);
	}
	for (i = 0; i < 10000000; i++)
	{
		sum += fx_s1516_longlong_div1(a, b);
	}
	for (i = 0; i < 10000000; i++)
	{
		sum += fx_s1516_longlong_div2(a, b);
	}
#endif

#ifdef fx_sin
	fx_s1516 a = 30;

	double fa = fx_to_double(a);

	printf("%lf\n", fx_s1516_double_sin(degree_to_radian(fa)));
	printf("%lf\n", fx_s1516_longlong_sin(a * P2_16) / fP2_16);

	for (i = 0; i < 10000000; i++)
	{
		sum += fx_s1516_double_sin(degree_to_radian(fa));
	}
	for (i = 0; i < 10000000; i++)
	{
		sum += (fx_s1516_longlong_sin(a * P2_16) / fP2_16);
	}
#endif

#ifdef fx_sqrt
	fx_s1516 a = 123;

	double fa = fx_to_double(a);

	printf("%lf\n", fx_s1516_double_sqrt(fa));
	printf("%lf\n", fx_s1516_longlong_sqrt(a) / 256.0);

	for (i = 0; i < 10000000; i++)
	{
		sum += fx_s1516_double_sqrt(fa);
	}
	for (i = 0; i < 10000000; i++)
	{
		sum += (fx_s1516_longlong_sqrt(a) / 256.0);
	}
#endif

	printf("%lf", sum);

	return 0;
}
